/***************************************************************************
 *   Copyright (C) 2006 by Borko Boskovic,                                 *
 *   borko.boskovic@uni-mb.si                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef SEARCH_H
#define SEARCH_H

#include <glib.h>

#include "position.h"
#include "move.h"
#include "startSearch.h"

#define Max_Depth 40
#define EVAL_MATE 30000
#define EVAL_DRAW 0

extern gboolean stopFlag;
extern gboolean parallelStopFlag;
extern gboolean ponderSearch;
extern gint searchMultipv;
extern guint64 searchNodes;
extern guint history[64][64];

extern const gint futilityValue1;
extern const gint futilityMargin1;
extern const gint futilityValue2;
extern const gint futilityMargin2;
extern const gint futilityValue3;
extern const gint futilityMargin3;

extern const gint HistoryFullDepthMoves;
extern const gint HistoryReductionLimit;

void iterativeDeepening(const Position* position, const guint64 maxNodes, const guint maxDepth);
gint search(Position* position, gint alpha, gint beta, gint depth, guint selDepth, gboolean nullMove);
gint quiescent(Position* position, gint alpha, gint beta, guint selDepth);

#endif
